# Injctive and Continuous Graph Neural Network (ICGNN)

## Dependencies
numpy

scipy

pytorch

networkx

pandas

pickle

sklearn

## Run
run the python command, it will generate a results folder containing the results.  

for simple graph classification
```
python graph_classification.py --dataset MUTAG --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat  --first_phi 
python graph_classification.py --dataset MUTAG --datapath ./datasets --hidden_dim 16 --phi vdmd --device 0 --fold_idx 0 --lr 0.01 --agg cat  --first_phi 

python graph_classification.py --dataset PTC --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.001 --agg cat  --first_phi 
python graph_classification.py --dataset PTC --datapath ./datasets --hidden_dim 16 --phi powvdmd --device 0 --fold_idx 0 --lr 0.001 --agg cat   

python graph_classification.py --dataset NCI1 --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.001 --agg cat   
python graph_classification.py --dataset NCI1 --datapath ./datasets --hidden_dim 64 --phi vdmd --device 0 --fold_idx 0 --lr 0.001 --agg cat  

python graph_classification.py --dataset PROTEINS --datapath ./datasets --hidden_dim 64 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat  
python graph_classification.py --dataset PROTEINS --datapath ./datasets --hidden_dim 64 --phi powvdmd --device 0 --fold_idx 0 --lr 0.001 --agg cat 

python graph_classification.py --dataset COLLAB --datapath ./datasets --hidden_dim 64 --phi MLP --device 0 --fold_idx 0 --lr 0.001 --agg cat  

python graph_classification.py --dataset IMDBBINARY --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat  

python graph_classification.py --dataset IMDBMULTI --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat  

python graph_classification.py --dataset REDDITBINARY --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat  
```

for attributed graph classification
```
python graph_classification.py --dataset ENZYMES --datapath ./datasets --hidden_dim 64 --phi MLP --device 0 --fold_idx 0 --lr 0.001 --agg cat --attribute --first_phi  --norm
python graph_classification.py --dataset ENZYMES --datapath ./datasets --hidden_dim 64 --phi vdmd --device 0 --fold_idx 0 --lr 0.001 --agg cat --attribute --first_phi  --norm

python graph_classification.py --dataset FRANKENSTEIN --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --fold_idx 0 --lr 0.001 --agg cat --attribute --first_phi 
python graph_classification.py --dataset FRANKENSTEIN --datapath ./datasets --hidden_dim 32 --phi powvdmd --device 0 --fold_idx 0 --lr 0.001 --agg cat --attribute --first_phi 

python graph_classification.py --dataset PROTEINSatt --datapath ./datasets --hidden_dim 64 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat --attribute --first_phi  --norm
python graph_classification.py --dataset PROTEINSatt --datapath ./datasets --hidden_dim 16 --phi powvdmd --device 0 --fold_idx 0 --lr 0.001 --agg cat --attribute --first_phi  --norm

python graph_classification.py --dataset SYNTHETICnew --datapath ./datasets --hidden_dim 64 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat --attribute --first_phi 
python graph_classification.py --dataset SYNTHETICnew --datapath ./datasets --hidden_dim 64 --phi vdmd --device 0 --fold_idx 0 --lr 0.01 --agg cat --attribute --first_phi 

python graph_classification.py --dataset Synthie --datapath ./datasets --hidden_dim 32 --phi MLP --device 0 --fold_idx 0 --lr 0.01 --agg cat --attribute --first_phi 
python graph_classification.py --dataset Synthie --datapath ./datasets --hidden_dim 64 --phi vdmd --device 0 --fold_idx 0 --lr 0.01 --agg cat --attribute --first_phi 
```

for node classification
```
python3 node_classification.py --dataset cora --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --train_ratio 0.8 --lr 0.01 --agg cat 
python3 node_classification.py --dataset cora --datapath ./datasets --hidden_dim 16 --phi vdmd --device 0 --train_ratio 0.8 --lr 0.01 --agg cat 

python3 node_classification.py --dataset citeseer --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --train_ratio 0.8 --lr 0.01 --agg cat 
python3 node_classification.py --dataset citeseer --datapath ./datasets --hidden_dim 16 --phi vdmd --device 0 --train_ratio 0.8 --lr 0.01 --agg cat 

python3 node_classification.py --dataset pubmed --datapath ./datasets --hidden_dim 16 --phi MLP --device 0 --train_ratio 0.8 --lr 0.01 --agg cat 
python3 node_classification.py --dataset pubmed --datapath ./datasets --hidden_dim 16 --phi vdmd --device 0 --train_ratio 0.8 --lr 0.01 --agg cat 
```